namespace com.progsbase.no.inductive.libraries.UUID_v0_1_0{

using static System.Math;

public class LinearCongruentialGenerator{
	public double x;
	public double a;
	public double c;
	public double m;
}
public class PseudorandomGenerator{
	public LinearCongruentialGenerator lcg;
}
public class BooleanArrayReference{
	public bool [] booleanArray;
}
public class BooleanReference{
	public bool booleanValue;
}
public class CharacterReference{
	public char characterValue;
}
public class NumberArrayReference{
	public double [] numberArray;
}
public class NumberReference{
	public double numberValue;
}
public class StringArrayReference{
	public StringReference [] stringArray;
}
public class StringReference{
	public char [] stringx;
}
public class UUID{
	public static char [] UUIDNilString(){
		char [] uuid;

		uuid = "00000000-0000-0000-0000-000000000000".ToCharArray();

		return uuid;
	}


	public static char [] GenerateUUID4String(PseudorandomGenerator random){
		char [] uuid4;
		double i, n;

		uuid4 = new char [36];

		for(i = 0d; i < 36d; i = i + 1d){
			n = PseudorandomNextIntegerBetween(random, 0d, 16d);
			uuid4[(int)(i)] = NumberToHexCharacter(n);
		}

		/* Add hyphens, version and variant info.*/
		uuid4[8] = '-';
		uuid4[13] = '-';
		uuid4[14] = '4';
		uuid4[18] = '-';
		uuid4[23] = '-';

		/* 8 means Variant 1.*/
		n = 8d + PseudorandomNextIntegerBetween(random, 0d, 4d);
		uuid4[19] = NumberToHexCharacter(n);

		return uuid4;
	}


	public static bool IsValidUUID4String(char [] str){
		bool valid;
		double i, n;

		valid = true;

		if(str.Length == 36d){
			if(str[8] == '-' && str[13] == '-' && str[18] == '-' && str[23] == '-'){
				if(str[14] == '4' && IsHexCharacterLowerCase(str[19])){
					n = HexCharacterToNumber(str[19]);

					if(n >= 8d){

						for(i = 0d; i < 36d; i = i + 1d){
							if(i != 8d && i != 13d && i != 18d && i != 23d){
								if(IsHexCharacterLowerCase(str[(int)(i)])){
								}else{
									valid = false;
								}
							}
						}
					}else{
						valid = false;
					}
				}else{
					valid = false;
				}
			}else{
				valid = false;
			}
		}else{
			valid = false;
		}

		return valid;
	}


	public static char NumberToHexCharacter(double n){
		char c;

		c = 'x';
		if(n == 0d){
			c = '0';
		}else if(n == 1d){
			c = '1';
		}else if(n == 2d){
			c = '2';
		}else if(n == 3d){
			c = '3';
		}else if(n == 4d){
			c = '4';
		}else if(n == 5d){
			c = '5';
		}else if(n == 6d){
			c = '6';
		}else if(n == 7d){
			c = '7';
		}else if(n == 8d){
			c = '8';
		}else if(n == 9d){
			c = '9';
		}else if(n == 10d){
			c = 'a';
		}else if(n == 11d){
			c = 'b';
		}else if(n == 12d){
			c = 'c';
		}else if(n == 13d){
			c = 'd';
		}else if(n == 14d){
			c = 'e';
		}else if(n == 15d){
			c = 'f';
		}

		return c;
	}


	public static double HexCharacterToNumber(char c){
		double n;

		n = 0d;
		if(c == '0'){
			n = 0d;
		}else if(c == '1'){
			n = 1d;
		}else if(c == '2'){
			n = 2d;
		}else if(c == '3'){
			n = 3d;
		}else if(c == '4'){
			n = 4d;
		}else if(c == '5'){
			n = 5d;
		}else if(c == '6'){
			n = 6d;
		}else if(c == '7'){
			n = 7d;
		}else if(c == '8'){
			n = 8d;
		}else if(c == '9'){
			n = 9d;
		}else if(c == 'a' || c == 'A'){
			n = 10d;
		}else if(c == 'b' || c == 'B'){
			n = 11d;
		}else if(c == 'c' || c == 'C'){
			n = 12d;
		}else if(c == 'd' || c == 'D'){
			n = 13d;
		}else if(c == 'e' || c == 'E'){
			n = 14d;
		}else if(c == 'f' || c == 'F'){
			n = 15d;
		}

		return n;
	}


	public static bool IsHexCharacterLowerCase(char c){
		bool valid;

		valid = true;

		if(c == '0'){
		}else if(c == '1'){
		}else if(c == '2'){
		}else if(c == '3'){
		}else if(c == '4'){
		}else if(c == '5'){
		}else if(c == '6'){
		}else if(c == '7'){
		}else if(c == '8'){
		}else if(c == '9'){
		}else if(c == 'a'){
		}else if(c == 'b'){
		}else if(c == 'c'){
		}else if(c == 'd'){
		}else if(c == 'e'){
		}else if(c == 'f'){
		}else{
			valid = false;
		}

		return valid;
	}


	public static bool IsHexCharacterUpperCase(char c){
		bool valid;

		valid = true;

		if(c == 'A'){
		}else if(c == 'B'){
		}else if(c == 'C'){
		}else if(c == 'D'){
		}else if(c == 'E'){
		}else if(c == 'F'){
		}else{
			valid = false;
		}

		return valid;
	}


	public static bool IsHexCharacter(char c){
		return IsHexCharacterLowerCase(c) || IsHexCharacterUpperCase(c);
	}


	public static LinearCongruentialGenerator CreateLinearCongruentialGeneratorNumericalRecipes(double seed){
		return CreateLinearCongruentialGeneratorCustom(Pow(2d, 32d), 1664525d, 1013904223d, seed);
	}


	public static LinearCongruentialGenerator CreateLinearCongruentialGeneratorCustom(double modulus, double multiplier, double increment, double seed){
		LinearCongruentialGenerator lcg;

		lcg = new LinearCongruentialGenerator();
		lcg.m = modulus;
		lcg.a = multiplier;
		lcg.c = increment;
		lcg.x = seed;

		return lcg;
	}


	public static double LinearCongruentialGeneratorNextNumber(LinearCongruentialGenerator lcg){
		lcg.x = Floor((lcg.a*lcg.x + lcg.c)%lcg.m);
		return lcg.x/lcg.m;
	}


	public static PseudorandomGenerator CreatePseudorandomNumberGenerator(double seed){
		PseudorandomGenerator prg;

		prg = new PseudorandomGenerator();
		prg.lcg = CreateLinearCongruentialGeneratorNumericalRecipes(seed);

		return prg;
	}


	public static double PseudorandomNextNumber(PseudorandomGenerator prg){
		return LinearCongruentialGeneratorNextNumber(prg.lcg);
	}


	public static double PseudorandomNextInteger(PseudorandomGenerator prg, double n){
		return Floor(PseudorandomNextNumber(prg)*n);
	}


	public static double PseudorandomNextIntegerBetween(PseudorandomGenerator prg, double a, double b){
		return Ceiling(a) + Floor(PseudorandomNextNumber(prg)*(b - a));
	}


	public static void AssertFalse(bool b, NumberReference failures){
		if(b){
			failures.numberValue = failures.numberValue + 1d;
		}
	}


	public static void AssertTrue(bool b, NumberReference failures){
		if(!b){
			failures.numberValue = failures.numberValue + 1d;
		}
	}


	public static void AssertEquals(double a, double b, NumberReference failures){
		if(a != b){
			failures.numberValue = failures.numberValue + 1d;
		}
	}


	public static void AssertBooleansEqual(bool a, bool b, NumberReference failures){
		if(a != b){
			failures.numberValue = failures.numberValue + 1d;
		}
	}


	public static void AssertCharactersEqual(char a, char b, NumberReference failures){
		if(a != b){
			failures.numberValue = failures.numberValue + 1d;
		}
	}


	public static void AssertStringEquals(char [] a, char [] b, NumberReference failures){
		if(!StringsEqual(a, b)){
			failures.numberValue = failures.numberValue + 1d;
		}
	}


	public static void AssertNumberArraysEqual(double [] a, double [] b, NumberReference failures){
		double i;

		if(a.Length == b.Length){
			for(i = 0d; i < a.Length; i = i + 1d){
				AssertEquals(a[(int)(i)], b[(int)(i)], failures);
			}
		}else{
			failures.numberValue = failures.numberValue + 1d;
		}
	}


	public static void AssertBooleanArraysEqual(bool [] a, bool [] b, NumberReference failures){
		double i;

		if(a.Length == b.Length){
			for(i = 0d; i < a.Length; i = i + 1d){
				AssertBooleansEqual(a[(int)(i)], b[(int)(i)], failures);
			}
		}else{
			failures.numberValue = failures.numberValue + 1d;
		}
	}


	public static void AssertStringArraysEqual(StringReference [] a, StringReference [] b, NumberReference failures){
		double i;

		if(a.Length == b.Length){
			for(i = 0d; i < a.Length; i = i + 1d){
				AssertStringEquals(a[(int)(i)].stringx, b[(int)(i)].stringx, failures);
			}
		}else{
			failures.numberValue = failures.numberValue + 1d;
		}
	}


	public static BooleanReference CreateBooleanReference(bool value){
		BooleanReference refx;
		refx = new BooleanReference();
		refx.booleanValue = value;

		return refx;
	}


	public static BooleanArrayReference CreateBooleanArrayReference(bool [] value){
		BooleanArrayReference refx;
		refx = new BooleanArrayReference();
		refx.booleanArray = value;

		return refx;
	}


	public static BooleanArrayReference CreateBooleanArrayReferenceLengthValue(double length, bool value){
		BooleanArrayReference refx;
		double i;
		refx = new BooleanArrayReference();
		refx.booleanArray = new bool [(int)(length)];

		for(i = 0d; i < length; i = i + 1d){
			refx.booleanArray[(int)(i)] = value;
		}

		return refx;
	}


	public static void FreeBooleanArrayReference(BooleanArrayReference booleanArrayReference){
		delete(booleanArrayReference.booleanArray);
		delete(booleanArrayReference);
	}


	public static CharacterReference CreateCharacterReference(char value){
		CharacterReference refx;
		refx = new CharacterReference();
		refx.characterValue = value;

		return refx;
	}


	public static NumberReference CreateNumberReference(double value){
		NumberReference refx;
		refx = new NumberReference();
		refx.numberValue = value;

		return refx;
	}


	public static NumberArrayReference CreateNumberArrayReference(double [] value){
		NumberArrayReference refx;
		refx = new NumberArrayReference();
		refx.numberArray = value;

		return refx;
	}


	public static NumberArrayReference CreateNumberArrayReferenceLengthValue(double length, double value){
		NumberArrayReference refx;
		double i;
		refx = new NumberArrayReference();
		refx.numberArray = new double [(int)(length)];

		for(i = 0d; i < length; i = i + 1d){
			refx.numberArray[(int)(i)] = value;
		}

		return refx;
	}


	public static void FreeNumberArrayReference(NumberArrayReference numberArrayReference){
		delete(numberArrayReference.numberArray);
		delete(numberArrayReference);
	}


	public static StringReference CreateStringReference(char [] value){
		StringReference refx;
		refx = new StringReference();
		refx.stringx = value;

		return refx;
	}


	public static StringReference CreateStringReferenceLengthValue(double length, char value){
		StringReference refx;
		double i;
		refx = new StringReference();
		refx.stringx = new char [(int)(length)];

		for(i = 0d; i < length; i = i + 1d){
			refx.stringx[(int)(i)] = value;
		}

		return refx;
	}


	public static void FreeStringReference(StringReference stringReference){
		delete(stringReference.stringx);
		delete(stringReference);
	}


	public static StringArrayReference CreateStringArrayReference(StringReference [] strings){
		StringArrayReference refx;
		refx = new StringArrayReference();
		refx.stringArray = strings;

		return refx;
	}


	public static StringArrayReference CreateStringArrayReferenceLengthValue(double length, char [] value){
		StringArrayReference refx;
		double i;
		refx = new StringArrayReference();
		refx.stringArray = new StringReference [(int)(length)];

		for(i = 0d; i < length; i = i + 1d){
			refx.stringArray[(int)(i)] = CreateStringReference(value);
		}

		return refx;
	}


	public static void FreeStringArrayReference(StringArrayReference stringArrayReference){
		double i;
		for(i = 0d; i < stringArrayReference.stringArray.Length; i = i + 1d){
			delete(stringArrayReference.stringArray[(int)(i)]);
		}
		delete(stringArrayReference.stringArray);
		delete(stringArrayReference);
	}


	public static double [] StringToNumberArray(char [] stringx){
		double i;
		double [] array;

		array = new double [(int)(stringx.Length)];

		for(i = 0d; i < stringx.Length; i = i + 1d){
			array[(int)(i)] = stringx[(int)(i)];
		}
		return array;
	}


	public static char [] NumberArrayToString(double [] array){
		double i;
		char [] stringx;

		stringx = new char [(int)(array.Length)];

		for(i = 0d; i < array.Length; i = i + 1d){
			stringx[(int)(i)] = (char)(array[(int)(i)]);
		}
		return stringx;
	}


	public static bool NumberArraysEqual(double [] a, double [] b){
		bool equal;
		double i;

		equal = true;
		if(a.Length == b.Length){
			for(i = 0d; i < a.Length && equal; i = i + 1d){
				if(a[(int)(i)] != b[(int)(i)]){
					equal = false;
				}
			}
		}else{
			equal = false;
		}

		return equal;
	}


	public static bool BooleanArraysEqual(bool [] a, bool [] b){
		bool equal;
		double i;

		equal = true;
		if(a.Length == b.Length){
			for(i = 0d; i < a.Length && equal; i = i + 1d){
				if(a[(int)(i)] != b[(int)(i)]){
					equal = false;
				}
			}
		}else{
			equal = false;
		}

		return equal;
	}


	public static bool StringsEqual(char [] a, char [] b){
		bool equal;
		double i;

		equal = true;
		if(a.Length == b.Length){
			for(i = 0d; i < a.Length && equal; i = i + 1d){
				if(a[(int)(i)] != b[(int)(i)]){
					equal = false;
				}
			}
		}else{
			equal = false;
		}

		return equal;
	}


	public static void FillNumberArray(double [] a, double value){
		double i;

		for(i = 0d; i < a.Length; i = i + 1d){
			a[(int)(i)] = value;
		}
	}


	public static void FillString(char [] a, char value){
		double i;

		for(i = 0d; i < a.Length; i = i + 1d){
			a[(int)(i)] = value;
		}
	}


	public static void FillBooleanArray(bool [] a, bool value){
		double i;

		for(i = 0d; i < a.Length; i = i + 1d){
			a[(int)(i)] = value;
		}
	}


	public static bool FillNumberArrayRange(double [] a, double value, double from, double to){
		double i, length;
		bool success;

		if(from >= 0d && from <= a.Length && to >= 0d && to <= a.Length && from <= to){
			length = to - from;
			for(i = 0d; i < length; i = i + 1d){
				a[(int)(from + i)] = value;
			}

			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static bool FillBooleanArrayRange(bool [] a, bool value, double from, double to){
		double i, length;
		bool success;

		if(from >= 0d && from <= a.Length && to >= 0d && to <= a.Length && from <= to){
			length = to - from;
			for(i = 0d; i < length; i = i + 1d){
				a[(int)(from + i)] = value;
			}

			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static bool FillStringRange(char [] a, char value, double from, double to){
		double i, length;
		bool success;

		if(from >= 0d && from <= a.Length && to >= 0d && to <= a.Length && from <= to){
			length = to - from;
			for(i = 0d; i < length; i = i + 1d){
				a[(int)(from + i)] = value;
			}

			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static double [] CopyNumberArray(double [] a){
		double i;
		double [] n;

		n = new double [(int)(a.Length)];

		for(i = 0d; i < a.Length; i = i + 1d){
			n[(int)(i)] = a[(int)(i)];
		}

		return n;
	}


	public static bool [] CopyBooleanArray(bool [] a){
		double i;
		bool [] n;

		n = new bool [(int)(a.Length)];

		for(i = 0d; i < a.Length; i = i + 1d){
			n[(int)(i)] = a[(int)(i)];
		}

		return n;
	}


	public static char [] CopyString(char [] a){
		double i;
		char [] n;

		n = new char [(int)(a.Length)];

		for(i = 0d; i < a.Length; i = i + 1d){
			n[(int)(i)] = a[(int)(i)];
		}

		return n;
	}


	public static bool CopyNumberArrayRange(double [] a, double from, double to, NumberArrayReference copyReference){
		double i, length;
		double [] n;
		bool success;

		if(from >= 0d && from <= a.Length && to >= 0d && to <= a.Length && from <= to){
			length = to - from;
			n = new double [(int)(length)];

			for(i = 0d; i < length; i = i + 1d){
				n[(int)(i)] = a[(int)(from + i)];
			}

			copyReference.numberArray = n;
			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static bool CopyBooleanArrayRange(bool [] a, double from, double to, BooleanArrayReference copyReference){
		double i, length;
		bool [] n;
		bool success;

		if(from >= 0d && from <= a.Length && to >= 0d && to <= a.Length && from <= to){
			length = to - from;
			n = new bool [(int)(length)];

			for(i = 0d; i < length; i = i + 1d){
				n[(int)(i)] = a[(int)(from + i)];
			}

			copyReference.booleanArray = n;
			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static bool CopyStringRange(char [] a, double from, double to, StringReference copyReference){
		double i, length;
		char [] n;
		bool success;

		if(from >= 0d && from <= a.Length && to >= 0d && to <= a.Length && from <= to){
			length = to - from;
			n = new char [(int)(length)];

			for(i = 0d; i < length; i = i + 1d){
				n[(int)(i)] = a[(int)(from + i)];
			}

			copyReference.stringx = n;
			success = true;
		}else{
			success = false;
		}

		return success;
	}


	public static bool IsLastElement(double length, double index){
		return index + 1d == length;
	}


	public static double [] CreateNumberArray(double length, double value){
		double [] array;

		array = new double [(int)(length)];
		FillNumberArray(array, value);

		return array;
	}


	public static bool [] CreateBooleanArray(double length, bool value){
		bool [] array;

		array = new bool [(int)(length)];
		FillBooleanArray(array, value);

		return array;
	}


	public static char [] CreateString(double length, char value){
		char [] array;

		array = new char [(int)(length)];
		FillString(array, value);

		return array;
	}


	public static void SwapElementsOfArray(double [] A, double ai, double bi){
		double tmp;

		tmp = A[(int)(ai)];
		A[(int)(ai)] = A[(int)(bi)];
		A[(int)(bi)] = tmp;
	}


	public static void delete(System.Object objectx){
		// C# has garbage collection.
	}
}

}